/**
 *
 *
 */

#ifndef __LIBRARY_HASH
#define __LIBRARY_HASH

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if defined(_BSD_) || defined(_SOLARIS_)
#include <sys/inttypes.h>
#else
#include <stdint.h>
#endif

#ifndef ___DEFAULT_CAPACITY
#define __DEFAULT_CAPACITY    109
#endif

#define LHInitHash(s)       _LHInitHash(s)
#define LHSetValue(t, k, v) _LHSetValue(t, k, strlen(k), v)
#define LHGetValue(t, k)    _LHGetValue(t, k, strlen(k))
#define LHRemoveValue(t, k) _LHRemoveValue(t, k, strlen(k))
#define LHSetFull(t, s)     _LHSetFull(t, s)
#define LHFreeHash(t,f)     _LHFreeHash(t,f)

typedef struct THashNode {
  struct THashNode *ptNextNode;
  char             *pxKey;
  size_t           iKeyLength;
  void             *pvData;
} THashNode;

typedef struct THashTable {
  THashNode **pptNodes;
  int       iNbEntries;
  size_t    iCapacity;
  float     fFullSize;
  THashNode *ptCurrentSearchNode;
  int       iCurrentSearchNode;
} THashTable;

THashTable * _LHInitHash( size_t );
void _LHFreeHash( THashTable *, void (*callback) (void * ) );
long _LHSetValue( THashTable*, const char*, size_t, void * );
void _LHSetFull( THashTable *, float );
void *_LHGetValue( THashTable*, const char*, size_t );
void *_LHRemoveValue( THashTable*, const char*, size_t );

void LHInitSearch( THashTable * );
THashNode *LHSearchNext( THashTable * );

#endif // __LIBRARY_HASH
