#!/usr/bin/ruby -w
# See the LICENSE file for copyright and distribution information

require "mkmf"

$LIBPATH.push(Config::CONFIG['libdir'])

def crash(str)
  print(" extconf failure: %s\n", str)
  exit 1
end

dir_config('dotneato')

unless have_library("dotneato", "dotneato_initialize")
  crash(<<EOL)
need libdotneato.

        Install the library or try one of the following options to extconf.rb:

        --with-dotneato-dir=/path/to/graphviz
        --with-dotneato-lib=/path/to/graphviz/lib
        --with-dotneato-include=/path/to/graphviz/include
EOL
end

$LDFLAGS << ' ' + `dotneato-config --libs`.chomp

$CFLAGS << ' ' + `dotneato-config --cflags`.chomp
$CFLAGS = '-g -Wall ' + $CFLAGS


create_header()
create_makefile("graphviz")
