#!/usr/bin/ruby

$:.unshift( ".." );
require "graphviz"
require 'stringio'

def redirect
  orig_stdout = $stdout
  $stdout = StringIO.new
  yield
  $stdout.string
ensure
  $stdout = orig_stdout
end

$stdout = STDERR
print "GraphViz v", GraphViz::VERSION, "\n"
$stdout = STDOUT

hh = Hash::new

## layout == GraphViz::DOT GraphViz::NEATO GraphViz::TWOPI
hh["layout"] = GraphViz::DOT

## type == GraphViz::AGRAPH GraphViz::AGRAPHSTRICT GraphViz::AGDIGRAPH GraphViz::AGDIGRAPHSTRICT
hh["type"]   = GraphViz::AGDIGRAPH

## output == ps ps2 hpgl pcl mif pic gd gd2 gif jpg jpeg png wbmp ismap imap cmap vrml vtx 
##           mp fig svg svgz dia dot canon plain plain-ext xdot
hh["output"] = "png"

gv = GraphViz::new( "graph", hh )

## Rem: add_node( "node name", "node label" );
gv.add_node( "n1", "Ruby" )
gv.add_node( "n2", "GraphViz" )
gv.add_node( "n3", "This is\na test" )
gv.add_node( "n4", "Yaaaa !\nIt works !" )

## Rem: add_edge( "edge name", "node #1", "node #2" );
gv.add_edge( "e1", "n1", "n2" )
gv.add_edge( "e2", "n2", "n1" )
gv.add_edge( "e3", "n3", "n1" )
gv.add_edge( "e4", "n3", "n2" )
gv.add_edge( "e5", "n1", "n4" )
gv.add_edge( "e5", "n2", "n4" )
gv.add_edge( "e5", "n3", "n4" )

## Rem: add_(node|edhe)_attr( "attribut name", "attribut value" )
gv.add_node_attr( "color", "blue" );
gv.add_node_attr( "shape", "ellipse" );

gv.add_edge_attr( "color", "grey" );
gv.add_edge_attr( "style", "filled" );

## Rem: set_(node|edge)_attr( "(node|edge) name", "attribut name", "attribut value" );
gv.set_node_attr( "n2", "color", "red" );
gv.set_node_attr( "n4", "shape", "polygon" );

gv.set_edge_attr( "e2", "color", "black" );
gv.set_edge_attr( "e5", "style", "bold" );

outputStr = redirect { 
  gv.output()
}
print outputStr
